/* $Id: edit-list.c 84 2005-03-06 01:10:58Z jesus $ */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "data.h"

/* creates a new FILELIST */
FILELIST newFileList() {
  FILELIST filelist;
  filelist = (FILELIST) malloc(sizeof(struct filelist));
  filelist->count = 0;
  filelist->max = 0;
  filelist->playing_file = NONE;
  filelist->selected_file = 0;
  filelist->status = 0;
  return filelist;
}

/* creates a new FILEENTRY with filename */
FILEENTRY newFileEntry(char *filename) {
  FILEENTRY new;
  new = (FILEENTRY) malloc(sizeof(struct fileentry));
  new->filename = filename;
  new->inqueue = 0;
  return new;
}

/* adds the FILEENTRY *file to alist */
void addToList(FILELIST alist, FILEENTRY file) {
  if (alist->max == 0) {
    alist->list = malloc(sizeof(FILEENTRY));
    alist->max = 1;
  } else if ((alist->count + 1) > alist->max) {
    alist->max *= 2;
    alist->list = realloc(alist->list, sizeof(FILEENTRY) * alist->max);
  }

  if (alist->status & randomize) {
    FILEENTRY old;
    int ran;

    if (alist->count > 0) {
      ran = (int) (alist->count * (rand() / (RAND_MAX + 1.0)));
      if (ran == alist->playing_file)
        alist->playing_file = alist->count;
      old = alist->list[ran];
      alist->list[alist->count] = old;
      alist->list[ran] = file;
    } else {
      alist->list[0] = file;
    }
  } else {
    alist->list[alist->count] = file;
  }
  // alist->list[alist->count]->inqueue = 1;
  alist->count++;
}

/* removes FILEENTRY *file from list, if exists */
void removeFromList(FILELIST alist, FILEENTRY file) {
  int i;

  for (i = 0; i < alist->count; i++) {
    if (alist->list[i] == file) {
      alist->list[i]->inqueue = 0;
      alist->count--;
      break;
    }
  }
  for (; i < alist->count; i++) {
    alist->list[i] = alist->list[i + 1];
    if (alist->list[i] == file)
      alist->list[i]->inqueue = 1;
  }
}

/* merges FILELIST blist into FILELIST alist */
void mergeFileLists(FILELIST alist, FILELIST blist) {
  int i;

  for (i = 0; i < blist->count; i++)
    addToList(alist, blist->list[i]);
}

/* returns the id of the FILEENTRY file in alist */
int getIDinList(FILELIST alist, FILEENTRY file) {
  int i;
  for (i = 0; i < alist->count; i++) {
    if (alist->list[i] == file)
      return i;
  }
  return -1;
}
