/* $Id: globals.h 94 2005-03-12 16:43:09Z jesus $ */

#ifndef _QP_GLOBALS_H
#define _QP_GLOBALS_H

#include <sys/select.h>
#include "data.h"

#define CP_DEFAULT 1
#define CP_SELECTED 2
#define CP_HELPLINE 3
#define CP_INPUTLINE 4

#define KEY_ESC 27
#define KEY_TAB 8

#define SHELL "/bin/sh"

#define DEFAULT_FMT_STRING \
  "%03i %{%a%t?%{%a?%a%{%t? - }}%{%t?%t}:%n}%{%S? [%S]}%>  %{%q?[%q] }%{%s?%s%{%T?/}}%T"

#define DEFAULT_STATUS_FMT_STRING \
  "playing > %03i %{%a%t?%{%a?%a%{%t? - }}%{%t?%t}:%n}%{%S? [%S]} (%{%s?%s%{%T?/}}%T)%> "

extern int startline;

extern unsigned shuffle;
extern unsigned repeat;

extern int debug;

extern FILELIST queuelist;      /* the queuelist with songs to play next */
extern FILEENTRY filetoplay;    /* the current playing file out of the queuelist */
extern FILELIST actuallist;     /* the current sorted list with FILEENTRYs */

extern char *inputline;
extern int inputmode;
extern int inputchars;

extern char *errorline;
extern int errormode;

extern int rredraw;

extern FILELIST filelist;       /* list of all files */
extern QP_KEYMAP keymap;

extern fd_set fds_copy;
extern int remote;

extern int LINES;

extern char *format;            /* old */
extern struct fmt_entry **fmt;
extern struct fmt_entry **status_fmt;

#define DISPLAYED_LINES (LINES - 3)

#define FUNC(call, list, args...) /* call module function from list */ \
  list->function->call(list, ##args)

#endif /* _QP_GLOBALS_H */
