/* $Id: qplay.h 59 2005-02-17 00:54:05Z jesus $ */

#ifndef _QPLAY_H
#define _QPLAY_H

#include <stdio.h>
#include <stdlib.h>

#include "config.h"

#define BUFSIZE 256

extern int debug;

#ifdef DEBUG
#define PRINT_DEBUG(debuglevel, msg...) \
  if (debug > debuglevel) { \
    fprintf(stdout, "debug[%s:%d]: ", __FILE__, __LINE__); \
    fprintf(stdout, msg); \
    fprintf(stdout, "\r"); \
    fflush(stdout); \
  }
#else
#define PRINT_DEBUG(debuglevel, msg...)
#endif

#define ERROR(debuglevel, msg...) \
  fprintf(stderr, "\e[1;31mERROR\e[0m"); \
  if (debug > debuglevel) \
    fprintf(stderr, "[%s:%d]", __FILE__, __LINE__); \
  fprintf(stderr, ": "); \
  fprintf(stderr, msg); \
  fprintf(stderr, "\r\n"); \
  fflush(stderr); \
  exit(EXIT_FAILURE);

#define WARNING(debuglevel, msg...) \
  fprintf(stderr, "\e[1;33mWARNINGR\e[0m"); \
  if (debug > debuglevel) \
    fprintf(stderr, "[%s:%d]", __FILE__, __LINE__); \
  fprintf(stderr, ": "); \
  fprintf(stderr, msg); \
  fprintf(stderr, "\r\n"); \
  fflush(stderr);

#endif /* _QPLAY_H */
