/* $Id: read-dir.c 94 2005-03-12 16:43:09Z jesus $ */

#include <sys/types.h>          /* opendir:stat */
#include <dirent.h>             /* opendir */

#include <sys/stat.h>           /* stat */
#include <unistd.h>             /* stat */

#include <string.h>             /* strdup */

#include "qplay.h"              /* PRINT_DEBUG */
#include "edit-list.h"
#include "read-dir.h"
#include "data.h"

void get_file_list(int remote, struct pathlist *plist, int recursive) {
  DIR *dir;
  struct dirent *entry;
  struct stat stat_buf;
  // FILELIST filelist = newFileList();
  int i;
  char wholepath[512];

  fd_set rfds;
  FD_ZERO(&rfds);
  FD_SET(remote, &rfds);

  for (i = 0; i < plist->count; i++) {
    PRINT_DEBUG(2, "scanning: %s", plist->path[i]);
    if (stat(plist->path[i], &stat_buf) == 0) {
      if (S_ISDIR(stat_buf.st_mode)) {
        if ((dir = opendir(plist->path[i])) != NULL) {
          while ((entry = readdir(dir)) != NULL) {
            if (entry->d_name[0] != '.') {
              strcpy(wholepath, plist->path[i]);
              if (plist->path[i][strlen(plist->path[i]) - 1] != '/')
                strcat(wholepath, "/");
              strcat(wholepath, entry->d_name);
              if (stat(wholepath, &stat_buf) == 0) {
                if (S_ISDIR(stat_buf.st_mode) && !recursive)
                  continue;
                if ((plist->count + 1) > plist->max) {
                  plist->max *= 2;
                  plist->path =
                    (char **) realloc(plist->path, sizeof(char *) * plist->max);
                }
                plist->path[plist->count++] = strdup(wholepath);
              }
            }
          }
          closedir(dir);
        } else {
          perror(plist->path[i]);
        }
      } else if (S_ISREG(stat_buf.st_mode)) {
        // FILEENTRY new;
        // new = newFileEntry(path[i]);
        // addToList(filelist, new);
        int size;

        /* FIXME */
        if (select(16, NULL, &rfds, NULL, NULL) && FD_ISSET(remote, &rfds)) {
          size = strlen(plist->path[i]);
          write(remote, &size, sizeof(int));
          write(remote, plist->path[i], strlen(plist->path[i]));
        }
        // printf("wrote: %s\n", path[i]);
        // sleep(1);
      }
    }
  }
  free(plist->path);

  // return filelist;
}
