#include <stdio.h>              /* fopen, fgets, fclose */
#include <stdlib.h>             /* free */
#include <string.h>             /* strdup */
#include <sys/stat.h>           /* stat */
#include <unistd.h>             /* stat */

/*#include "qplay.h"              PRINT_DEBUG */
#include "edit-list.h"
#include "data.h"

static FILELIST parseFile(char *path);

FILELIST get_file_list_from_m3u(struct pathlist *plist) {
  struct stat stat_buf;
  FILELIST filelist = newFileList();
  FILELIST tmp;
  int i;

  /* for each string in path... */
  for (i = 0; i < plist->count; i++) {
    /* check if it is a regular file. */
    if (stat(plist->path[i], &stat_buf) == 0)
      if (S_ISREG(stat_buf.st_mode)) {
        /* yes, it is, so create a new file list from the file the path refers to, 
           and merge it into the filelist created by this function */
        tmp = parseFile(plist->path[i]);
        mergeFileLists(filelist, tmp);
        free(tmp);
        continue;
      }
    /* When the function arrives this point, there's something wrong... */
    // perror(path[i]);
  }
  free(plist->path);

  return filelist;
} /* get_file_list_from_m3u */

static FILELIST parseFile(char *path) {
  int i;
  FILELIST lfilelist = newFileList();
  /* We need a file descriptor */
  FILE *lfile;
  /* We need a char array as a buffer for the lines in path */
  char lbuf[256];
  /* We need a stat_buf-struct for checking the validity of the entries of path */
  struct stat stat_buf;
  /* We can assume, that path refers to a regular file, because get_list_from_m3u 
     checked that already. So, we can open the file and begin to read it. */
  lfile = fopen(path, "r");
  if (lfile != NULL) {          /* when the call of open was succesfull */
    /* read one line and check whether it is a regular file, until an error occurs or the end of the file 
       is reached */
    while (fgets(lbuf, 256, lfile)) {
      /* ignore lines beginning with "#" */
      if (lbuf[0] == '#')
        continue;
      /* checking whether lbuf contains a valid path to a regular file and adding it to 
         our filelist */
      for (i = 0; i <= 256; i++)
        if (lbuf[i] == '\n') {
          lbuf[i] = '\0';
          break;
        }
      if (stat(lbuf, &stat_buf) == 0)
        if (S_ISREG(stat_buf.st_mode)) {
          FILEENTRY new;
          new = newFileEntry(strdup(lbuf));
          addToList(lfilelist, new);
        }
    }

  }
  /* we close the file, before we leave the function... */
  fclose(lfile);

  return lfilelist;
} /* parseFile */
